/**
 * YJ_News_Slider9
 * @version		1.0.1
 * @MooTools version 1.3+
 * Copyright Youjoomla.com
 * @author		Constantin Boiangiu <info [at] constantinb.com>
 */
var YJ_News_Slider9 = new Class({
  Implements: [Options],
  options: {
    container: null,
    slides: null,
    navigationContainer: null,
    navigationClass: null,
    navigationLoader: null,
	navigationLoaderON: 0,
    transition: Fx.Transitions.Sine.easeOut,
    effectDuration: 500,
    infoElem: '.info',
    fromTop: 500,
    topDist: 100,
    slideDelay: 5000
  },
  initialize: function (options) {
    this.setOptions(options);
    if (!this.options.container) return;
    this.container = $(this.options.container);
    this.slides = this.container.getElements(this.options.slides);
    this.start();
  },
  start: function () {
    this.elements = $(this.options.container).getElements(this.options.slides);
    this.navs = $(this.options.navigationContainer).getElements('a');
    this.currentElement = 0;
    this.elements.each(function (elem, i) {
      var nav = this.navs[i];
      if (i == this.currentElement) {
        nav.addClass('navLinkSelected');
      }
      elem.setStyles({
        'position': 'absolute',
        'top': 0,
        'left': 0,
        'opacity': (i == this.currentElement ? 1 : 0),
		'z-index':(100-i)
      });
      
	  var inf = elem.getElement(this.options.infoElem);
	  inf.setStyles({
		'top': this.options.fromTop
	  }).set('morph', {
		  'link': 'cancel', 
		  'duration': 300
	  });
	  this.elements[i]['fx'] = new Fx.Tween(elem, {
        duration: this.options.effectDuration,
        //this.options.effectDuration
        link: 'cancel',
        transition: this.options.transition
      });
      this.elements[i]['nav'] = nav;
      nav.addEvent('click', function (event) {
        if (this.currentElement == i) return;
        event.stop();
        clearTimeout(this.period);
        this.changeSlide(i);
        this.period = this.rotate.periodical(this.options.slideDelay, this);
      }.bind(this));
    }.bind(this));
    
	this.elements.addEvents({
		'mouseenter': function(){
			var info = this.elements[this.currentElement].getElement(this.options.infoElem);
			var curr = this.elements[this.currentElement];
			
			curr.setStyle('z-index',101);
			info.morph({
			  'top': this.options.topDist
			});
			clearTimeout(this.period);
		}.bind(this),
		'mouseleave': function(){
			var info =  this.elements[this.currentElement].getElement(this.options.infoElem);
			var curr = this.elements[this.currentElement];
			curr.setStyle('z-index',50);
			info.morph({
			  'top': this.options.fromTop
			});
			this.period = this.rotate.periodical(this.options.slideDelay, this);
		}.bind(this)
	  });
	
	
	this.period = this.rotate.periodical(this.options.slideDelay, this);
  },
	rotate: function(){
		if(this.options.slideDelay > 0){
			var i = this.currentElement+1 < this.elements.length ? this.currentElement+1 : 0;
			this.changeSlide(i);
		}else{
			var i = this.currentElement < this.elements.length ? this.currentElement : 0;
			
		}
	},
  changeSlide: function (i) {
	if(this.options.navigationLoaderON > 0){
    $(this.options.navigationLoader).addClass('preload');
    $(this.options.navigationLoader).setStyle('opacity', 0.8);
	}
    var fxc = new Fx.Tween(this.elements[this.currentElement], {
      link: 'chain'
    }).set('opacity', 1);
    fxc.start('opacity', 0);
    var fx = new Fx.Tween(this.elements[i], {
      duration: this.options.effectDuration,
      link: 'chain'
    }).set('opacity', 0).chain(function () {
	if(this.options.navigationLoaderON > 0){
      $(this.options.navigationLoader).removeClass('preload');
	}
    }.bind(this));
    fx.start('opacity', 1);
    this.elements[this.currentElement]['nav'].removeClass('navLinkSelected');
    this.elements[i]['nav'].addClass('navLinkSelected');
    this.currentElement = i;
  }
});